﻿Imports C1.Win.C1Chart

Public Class Chart_Zooming
    Dim mdx As Integer, mdy As Integer
    Dim mux As Double, muy As Double, x As Double, y As Double
    Dim flag As Integer = 0
    Dim rect As Rectangle

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        C1Chart1.SaveChartToFile("Chart1_Data.xml")
        C1Chart2.LoadChartFromFile("Chart1_Data.xml")
    End Sub

    Private Sub C1Chart1_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles C1Chart1.MouseUp
        Dim X__1 As Double = -1, Y__2 As Double = -1
        If C1Chart1.ChartGroups(0).CoordToDataCoord(e.X, e.Y, X__1, Y__2) Then
            ' data coordinates of the rectangular area selected
            ' at mouse up - mux,muy
            mux = X__1
            muy = Y__2
        End If

        ' Set the axis x & axis y's min & max points
        If rect.Width > 0 AndAlso rect.Height > 0 Then
            C1Chart2.ChartArea.AxisY.Max = y
            C1Chart2.ChartArea.AxisX.Min = x
            C1Chart2.ChartArea.AxisX.Max = mux
            C1Chart2.ChartArea.AxisY.Min = muy
        End If

        rect.Size = New Size(0, 0)
    End Sub

    Private Sub C1Chart1_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles C1Chart1.MouseDown
        rect.Size = New Size(0, 0)
        Dim X__1 As Double = -1, Y__2 As Double = -1
        If C1Chart1.ChartGroups(0).CoordToDataCoord(e.X, e.Y, X__1, Y__2) Then

            x = X__1
        End If
        y = Y__2

        ' See if the mouse down data coordinates lie in the plot area or not
        If (x >= C1Chart1.ChartArea.AxisX.Min AndAlso x <= C1Chart1.ChartArea.AxisX.Max) AndAlso (y >= C1Chart1.ChartArea.AxisY.Min AndAlso y <= C1Chart1.ChartArea.AxisY.Max) Then
            flag = 1
            ' data coordinates of the rectangular area selected
            ' at mouse down - mdx,mdy
            mdx = e.X
            mdy = e.Y
        Else
            flag = 0
        End If
    End Sub

    Private Sub C1Chart1_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles C1Chart1.MouseMove
        If e.Button = MouseButtons.Left Then
            If flag = 1 Then
                ' Draws the rectangle as the mouse moves
                rect = New Rectangle(mdx, mdy, e.X - rect.Left, e.Y - rect.Top)
            Else
                ' If the mouse down data coordinates do not lie in the plotting area then don not draw the rectangle
                rect.Size = New Size(0, 0)
            End If
        End If
        C1Chart1.Invalidate()
    End Sub

    Private Sub C1Chart1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles C1Chart1.Paint
        If flag = 1 Then
            C1Chart1.Invalidate()
            Using pen As New Pen(Color.Black, 1)
                e.Graphics.DrawRectangle(pen, rect)
            End Using
        End If
    End Sub
End Class
